import { isId, type Id } from "./Id";
import { hasOnlyKeys, hasProperty } from "./validation";

export interface GamePlayer {
	id: Id;
	username: string;
	isReady: boolean;
}

export function isGamePlayer(target: unknown): target is GamePlayer {
	if (!isId((target as any).id)) {
		return false;
	}

	if (!hasProperty(target, "username", "string")) {
		return false;
	}

	if (!hasProperty(target, "isReady", "boolean")) {
		return false;
	}

	return hasOnlyKeys(target, ["username", "id", "isReady"]);
}
