import { hasProperty, hasOnlyKeys } from "./validation";

export interface Me {
	id: string;
	role: string;
	username: string;
}

export function isMe(target: unknown): target is Me {
	if (!hasProperty(target, "id", "string")) return false;
	if (!hasProperty(target, "role", "string")) return false;
	if (!hasProperty(target, "username", "string")) return false;
	if (!hasOnlyKeys(target, ["id", "role", "username"])) return false;
	return true;
}
